#if !defined(__QPFETIIMPL_H)
#define	__QPFETIIMPL_H
#include <permon/private/qpimpl.h>
#include <permonqpfeti.h>

typedef struct _n_QPDirichletList *QPDirichletList;
struct _n_QPDirichletList {
  IS is;
  QPFetiNumberingType numtype;
  PetscBool enforce_by_B;
  QPDirichletList next;
};

typedef struct _n_QPFetiCtx *QPFetiCtx;
struct _n_QPFetiCtx {
  /* gluing data */
  IS i2g, l2g;
  ISLocalToGlobalMapping i2g_map, l2g_map;
  
  /* Dirichlet B.C. */
  QPDirichletList dbclist;

  PetscBool setupcalled;
};

FLLOP_EXTERN PetscErrorCode QPFetiAssembleDirichlet(QP qp, IS dbcis, QPFetiNumberingType numtype, PetscBool enforce_by_B);

FLLOP_EXTERN PetscErrorCode QPFetiCtxCreate(QPFetiCtx *ctxout);
FLLOP_EXTERN PetscErrorCode QPFetiCtxDestroy(QPFetiCtx ctx);
FLLOP_EXTERN PetscErrorCode QPFetiGetCtx(QP qp,QPFetiCtx *ctxout);

FLLOP_EXTERN PetscErrorCode QPDirichletListAdd(QPDirichletList *dbclist, IS dbcis, QPFetiNumberingType numtype, PetscBool enforce_by_B);
FLLOP_EXTERN PetscErrorCode QPDirichletListDestroy(QPDirichletList *dbclist);

FLLOP_EXTERN PetscErrorCode QPFetiCreateMapMatrix(MPI_Comm comm, PetscInt Nu, PetscInt ni, PetscInt mm_size, IS i2g, Mat *MapMatrix_new);  
FLLOP_EXTERN PetscErrorCode QPFetiGetI2Lmapping(MPI_Comm comm, IS l2g, IS i2g, IS *i2l_new);   
FLLOP_EXTERN PetscErrorCode QPFetiGetBgtSF(MPI_Comm comm, IS i2g, PetscInt Nu, IS i2l, PetscInt nl, PetscBool full_red, Mat *Bgt_out);
   
FLLOP_EXTERN PetscLogEvent QP_Feti_SetUp, QP_Feti_AssembleGluingFromNeighbors, QP_Feti_AssembleDirichlet;
FLLOP_EXTERN PetscLogEvent QP_Feti_AssemGluing, QP_Feti_GetBgtSF, QP_Feti_GetI2Lmapping, QP_AddEq; 
#endif
